# MAT-view: Visualization Tools for Multiple Aspect Trajectory Data Mining \[MAT-Tools Framework\]
---

\[[Publication](#)\] \[[citation.bib](citation.bib)\] \[[GitHub](https://github.com/mat-analysis/mat-view)\] \[[PyPi](https://pypi.org/project/mat-view/)\]


The present application offers a set of web tools to support the user in the visualization of multiple aspect trajectories and movelets (the parts of the trajectory that better discriminate a class). Also, present a detailed list of available datasets on a public repository, descriptions of MAT data mining methods, experimental results exploration, environmental and scripting generators. It integrates into a unique platform of the approaches available for multiple aspects trajectories and in general for multidimensional sequence classification into a unique web-based and python library system.

Created on Jun, 2024
Copyright (C) 2024, License GPL Version 3 or superior (see LICENSE file)

### Installation

Install directly from PyPi repository, or, download from github. (python >= 3.7 required)

```bash
    pip install mat-view
```

### Usage

This package enables a environment script to run the web application, just run:

```bash
    MAT-Web.py
```

By default Dash will run on http://127.0.0.1:8050/

\* In case you have trouble loading any data into the page (or an action is not updating the page), refresh the site and try again.

### Citing

If you use `mat-view` please cite the following paper:

**TODO**

Bibtex:
```bash
@inproceedings{...}
```

### Collaborate with us

Any contribution is welcome. This is an active project and if you would like to include your algorithm in `mat-view`, feel free to fork the project, open an issue and contact us.

Feel free to contribute in any form, such as scientific publications referencing `mat-view`, teaching material and workshop videos.

### Related packages

This package is part of _MAT-Tools Framework_ for Multiple Aspect Trajectory Data Mining, check the guide project:

- **[mat-tools](https://github.com/mat-analysis/mat-tools)**: Reference guide for MAT-Tools Framework repositories

And others:


### Change Log

This is a package under construction, see [CHANGELOG.md](./CHANGELOG.md)
